*^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^*
* Author      :                                                                *
*        Esteban Castorena Osuna                                               *
*        ECOlibs are on hold do to change in programming platform              *
*                                                                              *
*        Any Questions,Comments,Suggestions CIS : 75061,417                    *
*                                                                              *
* Permision of Use : You may use this code under the following conditions:     *
*                                                                              *
*        1) You Send $15.00 dollar donation  (its very nice code & worth it)   *
*                                                                              *
*              Send to :  Castorena                                            *
*                         1571 w 15th Street                                   *
*                         Yuma, Arizona  85364                                 *
*                         USA                                                  *
*                                                                              *
*        2) DO NOT Erase or Modify the author and Permission Part              *
*                                                                              *
*        3) Comply with the rules (so more code can be written)                *
*                                                                              *
*                                                    Thanks,  Esteban          *
*                                  ENJOY IT !!!                                *
*                                                                              *
* Definition  : miranda  --  if you don't have one, one will be provided       *
*                                                                              *
* Function    :                                                                *
*        GraphV(yt,xt,yb,xb,cArray,Title1,Title2,yTitle,xTitle,xSerie,NumSide) *
*                                                                              *
* Parameters  :                                                                *
*        yt,xt,yb,xb : int    top_row,top_column,bottom_row,bottom_column      *
*        cArray      : array that contains diferent graphs to plot             *
*                      each graph is an array that contains...                 *
*                  [1] char    'L' or 'B' -- Line Graph or Bar Graph           *
*                  [2] array   int        -- Numbers to Graph                  *
*                  [3] int     miranda    -- Color of graph                    *
*                  [4] int                -- If Line Graph attach to what      *
*                                            bar graph  : default center       *
*                  [5] string  miranda    -- Picture format of Graph Numbers   *
*                  [6] string             -- Graph Title                       *
*                  [7] bool               -- show numbers on graph             *
*                                            default .t.                       *
*        Title1      : Title of Completed Graph                                *
*        Title2      : Second Title of Completed Graph                         *
*        yTitle      : Title on the y axis                                     *
*        xTitle      : Title on the x axis                                     *
*        xSerie      : array  -- Data to display on each column's x axis       *
*        NumSide     : bool   -- Want the numbers to display at y axis         *
*                                                                              *
* Description :                                                                *
*        Display a Graph Line/Bar on the screen.                               *
*        Must be in Graph Mode before calling this function.                   *
*                                                                              *
* Returns     : LastBox   array containing arrays type                         *
*                  [1] char    -- Name of Graph                                *
*                  [2] int     -- color of Graph                               *
*                  [3] char    -- if Line Graph what character                 *
*                                  is assign to it.                            *
*                                                                              *
*^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^*


# Include 'Inkey.ch'

# DEFINE SCRBKGRN  1     // Screen Background
# DEFINE GRAPHLIN  14    // Graph Color

Static HighN,LowN,Elem,NumOfBars,LastBox
Static CharW,CharH

********************************************************************************
*****                                                                      *****
*****           Compile  \clip53\clipper Graph /n /w /DTEST                *****
*****               Link     exospace fi Graph li llibg                    *****
*****                                                                      *****
********************************************************************************

// begining area of testing
#ifdef TEST
Function Graphtest

   // Set GraphMode
   Set VIDEOMODE TO 18

   // Clear the whole screen
   grect(0,0,639,479,.t.,0,-1)


   GraphV(0,0,15,79,;
          {;
   /* Graph1 */   {'L',{61,52,29,89,83,54,65,53,23},,1,'99.9%','Line',.t.},;
   /* Graph2 */   {'B',{761,773,798,772,723,524,275,753,337},,,,'Bar',.t.},;
   /* Graph3 */   {'L',{161,452,329,189,383,954,165,353,223},,2,'999','Line',.t.},;
   /* Graph4 */   {'B',{661,252,529,789,883,454,635,553,273}, ,,'999','Bar',.t.};
          },;
           'Title A','Title B','Title y','Title x',{'Mon','Tue','Wed','Thu','Fri','Sat','Sun','MtoD','YtoD'},.f.)

   GraphV(15,0,29,39,;
          {;
          {'B',{61,52,29,89,83,54,65,53,23},,,'99.9%','Bar',.f.},;
          {'B',{611,152,219,891,831,541,615,153,123},,,       ,'Bar',.f.},;
          {'B',{161,452,329,789,383,954,165,353,223},,,'999' ,'Bar',.f.};
          },;
          'Title A',,'Title y','Title x',{'A','B','C','D','E','F','G','H','I'},.t.)


   GraphV(15,39,29,79,;
          {;
          {'L',{61,52,29,89,83,54,65,53,23},, 1,'99.9%','Line',.t.},;
          {'L',{621,522,229,289,823,542,652,523,223},,,,'Line',.t.};
          },;
          ,,,,,.f.)


   inkey(0)
   // Set TextMode
   Set VIDEOMODE TO 3
Retu .t.
#endif   // Finish area of testing



Function GraphV (yt,xt,yb,xb,cArray,Title1,Title2,yTitle,xTitle,xSerie,NumSide)
Local gxt,gyt,gxb,gyb,ymax,xmax,ydis,xdis,cont,cont2,LeftShift,LinePointer
Local yIncr,xIncr,bIncr,eSpac,BWidt,xSpaces,yTop,TempGraph,yAnt,xAnt
Local xBar,aArray,pixColor,xFix,xTit,NumberFormat,gName,NumTop,Longit,GraphType

   // Sort make sure all bars are before line graphs
   aArray:=Asort(cArray,,,{|x,y| x[1] < y[1]})

   // Start Calculations
   CalculaNum(aArray)
   Title1 = if(Title1==Nil,'',Title1)
   Title2 = if(Title2==Nil,'',Title2)
   xTitle = if(xTitle==Nil,'',xTitle)

   // if we Put #'s on Left of Screen, we need to make room for them
   NumSide = If(Numside==Nil,.f.,NumSide)
   LeftShift = If(NumSide,Len(Alltrim(PadL(HighN,20)))*5+5,3)

   // give one line room on the bottom for graph-info
   // also if a xtitle exist make room for that
   yb-= (1+if(!Empty(xTitle),1,0))

   // Set Character Height & Width
   CharH = 16
   CharW = 8

   // Clear area of graph
   grect(xt*CharW+3,yt*CharH,xb*CharW,yb*(3*CharH),.t.,0,-1)
                                 //16 for totals of lines 2 rows

   gyt   = yt*CharH                                // Graph Top Row
   gxt   = xt*CharW+LeftShift+if(yTitle==Nil,0,20) // Graph Top Col
   gyb   = yb*CharH                                // Graph Bot Row
   gxb   = xb*CharW                                // Graph Bot Col
   ymax  = HighN - LowN                            // Graph Height
   xmax  = Elem-1+Elem*3+(NumOfBars-1)*2           // Graph Width
   xdis  = (gxb-gxt)-1                             //
   xIncr = (xdis-Elem-1)/Elem                      // Maximum Space Between X Segments

   // Width of Each Bar and Width between them
   eSpac = Int(xIncr/(3+(NumOfBars-1)*2))
   BWidt = if(eSpac<=5,eSpac,Int((xIncr-(2+NumOfBars-1)*5)/NumOfBars))
   eSpac = if(eSpac<=5,eSpac,5)

   // figuring out room for titles
   If !Empty(Title1) .or. !Empty(Title2)
      cont = Max(Len(Title1),Len(Title2))*CharW
      xTit = Int(((gxb-gxt)-cont)/2)
      gyt += If(Empty(Title1),0,14) + If(Empty(Title2),0,14) + 4
      // if theres a xSeries display; make room for it
      if xSerie <> Nil
         gyb -= 17
      Endif
   Endif

   // calculate y coordinates
   ydis  = (gyb-gyt)-21       // 1 default + 15 up  + 5 down
   yIncr = ydis/ymax          // Maximum Space Between Y Segments


   // Start graphics
   // Draw a Rectangle around the Graph                           Y B L B L
   grect(gxt,gyt,gxb,gyb,.t.,SCRBKGRN,-1)      // Background  //  YXXXXXXXXXXX
   grect(gxt,gyt,gxb,gyb,.f.,GRAPHLIN,-1)      // Box
   gline(gxt+5,gyb-5,gxb-5,gyb-5,GRAPHLIN,-1)  // x-axis
   gline(gxt+5,gyt+5,gxt+5,gyb-5,GRAPHLIN,-1)  // y-axis

   // Put Titles  1-2
   If !Empty(Title1)
       gWriteAt(gxt+xTit,yt*CharH+2,PadC(Title1,(cont/CharW)),GRAPHLIN,-1)
   Endif
   If !Empty(Title2)
       gWriteAt(gxt+xTit,yt*CharH+2+if(Empty(Title1),0,14),PadC(Title2,(cont/CharW)),GRAPHLIN,-1)
   Endif

   // Put xTitle
   If !Empty(xTitle)
       cont = Len(xTitle)*CharW
       xTit = Int(((gxb-gxt)-cont)/2)
       gWriteAt(gxt+xTit,yb*CharH,PadC(xTitle,(cont/CharW)),GRAPHLIN,-1)
   Endif

   // Draw lines of x axis
   for cont = 1 to Elem-1
      gline(Int(gxt+5+cont*xIncr),gyb-10,Int(gxt+5+cont*xIncr),gyb-5,GRAPHLIN,-1)
      xFix = gxt+5
      if xSerie <> Nil
         For cont2 = 1 to Len(xSerie)
            gWriteAt(xFix+3,yb*CharH-(CharH-1),xSerie[cont2],GRAPHLIN,-1)
            xFix+=xIncr
         next
      endif
   Next

   // Draw lines of y axis
   for cont = gyb-5 to gyt Step -20
       gline(gxt,cont,gxt+10,cont,GRAPHLIN,-1)
       Cont2 := Int((gyb-cont-5)/yIncr+LowN)
       If NumSide
          SmallNumb(Cont-3,gxt-LeftShift,Alltrim(PadL(cont2,20)),GRAPHLIN)
       Endif
   next

   // Write title of y axis
   If yTitle <> NIL
      WriteUpDn(gyt+Int((ydis-(Len(yTitle)*CharH))/2),gxt-LeftShift-9,yTitle,GRAPHLIN)
   Endif

   // Graph the numbers
   xSpaces  = eSpac ; xBar:={}
   For cont2 = 1 to Len(aArray)

      // Graph parameters
      TempGraph:=aArray[cont2]

      Longit = Len(TempGraph)               // # of Paramters
      Graphtype = Upper(TempGraph[1])       // B)ar L)ine

      // Color of Graph
      PixColor = if(Longit<=2,;
                    gColor(Graphtype),;     // assign one
                    If(TempGraph[3]==Nil,;  // is it a valid color ?
                    gColor(Graphtype),;     // assign one
                    TempGraph[3]))

      // Name of Graph
      gName    = if(Longit<=5,;
                    'Sin Nombre',;          // set default
                    If(TempGraph[6]==Nil,;  // is it a valid name
                       'Sin Nombre',;       // set default
                       TempGraph[6]))

      // Want Numbers on Graphs
      NumTop   = if(Longit<=4,;
                    .f.,;                   // default no numbers
                    If(TempGraph[7]==Nil,;
                       .f.,;                // default no numbers
                       TempGraph[7]))       // assign value

      // If don't want numbers on the side and wants them on the graph
      If !NumSide .and. NumTop
         // Let's get the format -- if exist assign if not MakeFormat
         NumberFormat = If(Longit>4 .and. TempGraph[5]<>Nil,TempGraph[5],MakeFormat(TempGraph[2]))
      Endif


      // Get the line pointer  (character to plot the points)
      LinePointer:=if(Graphtype=='B',Nil,gPointer())

      // LastBox keeps track of the diferent graphs (bars and lines)
      //   to display its information on the char a the bottom
      Aadd(Lastbox,{gName,PixColor,LinePointer,NumberFormat})

      If Graphtype == 'B'                // It's a Bar Graph
         For cont = 1 to Len(TempGraph[2])
            // How high should it go ?
            yTop = gyb - Int((TempGraph[2][cont]-LowN)*yIncr) - 5
            // Get the X Coordinate !
            xfix = gxt+5+xSpaces+Int((cont-1)*xIncr)
            // Draw Bar
            grect(xFix,gyb-5,BWidt+xFix,yTop,.t.,PixColor,-1)
            // Put SmallNumbers on Top of Bar
            If !NumSide .and. NumTop
               SmallNumb(ytop-12,Int((BWidt-(Len(NumberFormat)*4))/2)+xFix,Str(TempGraph[2][cont],12,2),GRAPHLIN,NumberFormat)
            Endif
         Next
         // xBar is in case you want a line graph to attach in the middle
         //   of this bar
         Aadd(xBar,xSpaces+Int(Bwidt/2)+gxt+5)
         xSpaces += eSpac+BWidt
      Else                                 // It's a Line Graph
         yAnt = 0 ; xAnt = 0
         For cont = 1 to Len(TempGraph[2])
            // How high should it go ?
            yTop = gyb - Int((TempGraph[2][cont]-LowN)*yIncr) - 5
            // Get the X Coordinate !
            xFix = gxt+5+Int((cont-1)*xIncr)+Int(xIncr/2)
            // do we want the line attached to some bar  (parameter TempGraph[4])
            If (Len(TempGraph)>3) .and. (TempGraph[4] <> Nil) .and. (TempGraph[4] <= Len(xBar))
               xFix = xBar[TempGraph[4]]+Int((cont-1)*xIncr)
            Endif
            // Put SmallNumbers on Top of Line
            If !NumSide .and. NumTop
               SmallNumb(ytop-12,Int(-(Len(NumberFormat)*4)/2)+xFix,Str(TempGraph[2][cont],12,2),GRAPHLIN,NumberFormat)
            endif
            //Draw the Line
            gLine(if(xAnt==0,xFix,xAnt),if(yAnt==0,yTop,yAnt),;
                  xFix,yTop,PixColor,-1)
            // Put the LinePointer
            gWriteAt(xFix-4,yTop-7,Chr(LinePointer),PixColor,-1)
            yAnt = yTop
            xAnt = xFix
         Next
      Endif
   Next

   // Do we want the numbers on the side?
   If NumSide
      for cont = gyb-5 to gyt Step -20
         for cont2 = gxt+5 to gxb-5 Step 10
          gputpixel(cont2,cont,GRAPHLIN,-1)
         next
      next
   Endif

   // Put NumTitles At Bottom
   cont = Len(LastBox)*6 - 2
   Aeval(LastBox,{|Elem| cont += Len(Elem[1])})
   xFix = (xt + Int(((xb-xt)-cont)/2)) * CharW
   yAnt = (yb+if(Empty(xTitle),0,1))*CharH + 2
   for cont = 1 to Len(LastBox)
      if LastBox[cont][3]==Nil  // is a Line description
         grect(xFix,yAnt,xFix+3*CharW,yAnt+14,.t.,LastBox[cont][2],-1)
      else                      // is a Bar  description
         gWriteAt(xFix,yAnt,'',0,-1)
         gWriteAt(xFix,yAnt,'-'+chr(LastBox[cont][3])+'-',LastBox[cont][2],-1)
      endif
      xfix+=4*CharW
      gWriteAt(xFix,yAnt,LastBox[cont][1]+'  ',GRAPHLIN,-1)
      xFix+=Len(LastBox[cont][1]+'  ')*CharW
   next

return LastBox


// make picture for a Numeric Value or a Numeric Array
Stat Func MakeFormat(Value)
local NumFormat:='',RVal:='',a,b
   if ValType(Value) == 'A'
      AEval(Value,{|Elem| b:=Alltrim(str(Elem)),NumFormat:=if(Len(b)>Len(NumFormat),b,NumFormat) })
   else
      NumFormat = Alltrim(str(Value))
   endif
   for a = 1 to len(NumFormat)
      RVal += if(SubStr(NumFormat,a,1) $ '0123456789','9',SubStr(NumFormat,a,1))
   next
retu RVal


* Calculate HighN,LowN,Elem,NumOfBars
Static Function CalculaNum(aArray)
Local MaxN,Hig,Count,Ele,Low,TempA
   Hig:={} ; Ele:={} ; Low:={}
   NumOfBars = 0
   For Count = 1 to Len(aArray)
      // Put Max Number in first element
      TempA:=ACLONE(aArray[Count][2])
      MaxN := ASort(TempA,,,{|x,y| x>y})
      Aadd(Hig,MaxN[1])
      Aadd(Ele,Len(MaxN))
      If(aArray[Count][1] == 'B',NumOfBars++,)
      Aadd(Low,MaxN[Len(MaxN)])
   Next
   MaxN := ASort(Ele,,,{|x,y| x>y})
   Elem  = MaxN[1]   // Longitud - How many diferent bars - spaces
   MaxN := ASort(Hig,,,{|x,y| x>y})
   HighN = MaxN[1]   // make maximum stay at bottom
   MaxN := ASort(Low,,,{|x,y| x<y})
   LowN  = MaxN[1]   // make minimum stay at top
   If NumOfBars == 0 ; NumOfBars = 1 ; Endif
   LastBox :={}
Return Nil

// Assgin a Pointer for Line Graphs
Static Function gPointer(Reset)
Static Nextone:=0,;
       Pointers:={9,15,30,31,232,127,233}
       If Nextone >= 7 ; NextOne=0 ; Endif
Return Pointers[++Nextone]

// Select colors
Static Function gColor(Tipo)  // Tipo B ars / L ines  (Dim color for bars)
Static Nextone:=0,;
       Colors:={2,10,3,11,4,12,5,13,6,14,7,15}
       // Colors xyxyxyxy   where x are dim colors and y are brighter
       NextOne += If(Tipo=='L',1,0)
       If Nextone >= Len(Colors) ; NextOne=0 ; Endif
Return Colors[++NextOne]


// Paint small numbers  -- kind of slow  // but it works!
Static Function SmallNumb(ny,nx,cNumb,nColor,estr)
Static Numeros:={{ 6, 9, 9, 9, 9, 9, 9, 6},;  // 0
                 { 6, 2, 2, 2, 2, 2, 2, 7},;  // 1
                 { 6, 9, 1, 2, 4, 8, 8,15},;  // 2
                 { 6, 9, 1, 2, 2, 1, 9, 6},;  // 3
                 { 1, 3, 5, 9,15, 1, 1, 1},;  // 4
                 {15, 8, 8,14, 1, 1, 1,14},;  // 5
                 { 6, 9, 8,14, 9, 9, 9, 6},;  // 6
                 {15, 1, 1, 1, 2, 2, 2, 2},;  // 7
                 { 6, 9, 9, 6, 9, 9, 9, 6},;  // 8
                 { 6, 9, 9, 9, 7, 1, 1, 1},;  // 9
                 { 0, 8, 1, 2, 4, 8, 1, 0},;  // %
                 { 6, 6, 9, 4, 2, 9, 6, 6},;  // $
                 { 0, 0, 0, 0, 0, 0, 0, 0},;  //
                 { 0, 0, 0, 0, 0, 0, 6, 6},;  // .
                 { 0, 6, 9, 9, 9,15, 9, 9},;  // a
                 { 9,15,15,15, 9, 9, 9, 9},;  // m
                 {15, 9, 9, 9,15, 8, 8, 8}}   // p

Local  x,y,z,c,nc,lenc,rs
       if Val(cNumb) == 0
         Retu Nil
       endif
       if estr<>Nil
          cNumb=Transform(val(cNumb),estr)
       endif
       lenc = Len(cNumb)
       rs:={'','','','','','','',''}
       For x = 1 to Lenc
           c = SubStr(cNumb,1,1)
           cNumb = SubStr(cNumb,2)
           Do Case
           Case c=='%' ; c = '10'
           Case c=='$' ; c = '11'
           Case c==' ' ; loop       // Space 12
           Case c=='.' ; c = '13'
           Case c=='a' ; c = '14'
           Case c=='m' ; c = '15'
           Case c=='p' ; c = '16'
           EndCase
           for y = 1 to 8
              nc = Right(num2bin(Numeros[Val(c)+1][y]),4)
              rs[y]+=nc+'0'
           next
       next
       for z = 1 to len(rs)
         for x = 1 to len(rs[z])
            If SubStr(rs[z],x,1) == '1'
               gPutPixel(nx+x,ny+z-1,nColor,-1)
            Endif
         next
       next


/*
    0000  0110              6
    0000  1001              9
    0000  1001  <-- example 9
    0000  1001    # 0       9
    0000  1001              9
    0000  1001              9
    0000  1001              9
    0000  0110              6
*/
Retu Nil

// Return Binary Number up to 4 chars
stat func Num2Bin(Number)
local Rval:='',x
   for x = 3 to 0 step -1
      Rval += if(Number >= 2^x,(Number:=Number-2^x,'1'),'0')
   next
retu Rval


Static Function WriteUpDn(ny,nx,cStrn,nColor)
Local x,lenc
   Lenc = Len(cStrn)
   For x = 1 to Lenc
      gWriteAt(nx,ny+(x-1)*CharH,SubStr(cStrn,x,1),nColor,-1)
   next
Retu Nil


